# Copyright (c) 2016 Oracle and/or its affiliates. All rights reserved. This
# code is released under a tri EPL/GPL/LGPL license. You can use it,
# redistribute it and/or modify it under the terms of the:
#
# Eclipse Public License version 1.0
# GNU General Public License version 2
# GNU Lesser General Public License version 2.1

require 'benchmark-interface/version'
require 'benchmark-interface/benchmark'
require 'benchmark-interface/benchmark-set'
require 'benchmark-interface/frontends/mri'
require 'benchmark-interface/backends/simple'
require 'benchmark-interface/backends/benchmark'
require 'benchmark-interface/backends/bips'
require 'benchmark-interface/backends/bench9000'
require 'benchmark-interface/require'
require 'benchmark-interface/run'

module BenchmarkInterface
  
  def self.benchmark(name=nil, &block)
    BenchmarkInterface::BenchmarkSet.current.register name, block
  end
  
end

def benchmark(name=nil, &block)
  BenchmarkInterface.benchmark name, &block
end

if $PROGRAM_NAME.split('/').last != 'benchmark'
  set = BenchmarkInterface::BenchmarkSet.new
  backend = BenchmarkInterface::Backends::Bips

  at_exit do
    set.prepare
    backend.run set, set.benchmarks, {}
  end
end
